// Author: A.Voss@FH-Aachen.de
//
// in and out file streams, string streams
// tags: ofstream, ifstream, fstream, stringstream, str

#include <iostream>
#include <cstdlib>
#include <string>
#include <fstream>
#include <sstream>
using namespace std;

#include "../../include/tools.h"

int main()
{
    // write file 1
    ofstream fout1("./test1.txt");
    if (fout1) {
        fout1 << "hello1" << endl;  
        fout1.close();
    }
    tools_log(); cout << "fout1-status: " << (0!=fout1) << endl;

    // write file 2
    ofstream fout2;
    fout2.open("./test2.txt");
    if (fout2) {
        fout2 << "hello2" << endl << "line2 word2" << endl << "line3 word3" << endl;  
        fout2.close();
    }
    tools_log(); cout << "fout2-status: " << (0!=fout2) << endl;
    
    // read file 1
    string s;
    ifstream fin1("./test1.txt");
    if (fin1) {
        fin1 >> s;
        fin1.close();
    }
    tools_log(); cout << "fin1-status:  " << (0!=fin1) << ", s=" << s << endl;

    // read file 2
    ifstream fin2("./test2.txt");
    if (fin2) {
        while (!fin2.eof()) {
            fin2 >> s;
            tools_log(); cout << "  read " << s << endl;
        }
        fin2.close();
    }
    tools_log(); cout << "fin2-status:  " << (0!=fin2) << endl;
 
    // modify file 2
    fstream fio("./test2.txt");
    if (fio) {
        fio.seekp(1);
        fio << "ELL";
        fio.close();
    }
    tools_log(); cout << "fio-status:   " << (0!=fio) << endl;
    
    // memory-stream
    stringstream sstream;
    sstream << s;
    tools_log(); cout << "sstream-str:  " << sstream.str() << endl;

    return EXIT_SUCCESS;
}

